%define anolis_release 2

Name:           xmlrpc-c
Version:        1.54.05
Release:        %{anolis_release}%{?dist}
Summary:        Lightweight RPC library based on XML and HTTP
# See doc/COPYING for details.
# The Python 1.5.2 license used by a few files is just BSD.
License:        BSD and MIT
URL:            http://xmlrpc-c.sourceforge.net/
Source0:        https://nchc.dl.sourceforge.net/project/xmlrpc-c/Xmlrpc-c%20Super%20Stable/%{version}/xmlrpc-c-%{version}.tgz

Patch1:         0001-xmlrpc_server_abyss-use-va_args-properly.patch
# enable openssl
Patch2:         0002-build-with-openssl.patch

BuildRequires:  git-core
BuildRequires:  meson >= 0.36.0
BuildRequires:  gcc
BuildRequires:  gcc-c++
Provides:       bundled(expat)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(libcurl)
BuildRequires:  readline-devel
BuildRequires:  ncurses-devel
BuildRequires:  libcurl-devel

%package c++
Summary:        C++ libraries for xmlrpc-c
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}

%package client
Summary:        C client libraries for xmlrpc-c
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}

%package client++
Summary:        C++ client libraries for xmlrpc-c
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-c++ = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-client = %{?epoch:%{epoch}:}%{version}-%{release}

%package devel
Summary:        Development files for xmlrpc-c based programs
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-c++ = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-client = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-client++ = %{?epoch:%{epoch}:}%{version}-%{release}

%package apps
Summary:        Sample XML-RPC applications
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-c++ = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-client = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       %{name}-client++ = %{?epoch:%{epoch}:}%{version}-%{release}

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch


%description
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C.


%description c++
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C++.


%description client
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C
clients.

%description client++
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C++
clients.


%description devel
Static libraries and header files for writing XML-RPC applications in
C and C++.


%description apps
XML-RPC is a quick-and-easy way to make procedure calls over the
Internet. It converts the procedure call into XML document, sends it
to a remote server using HTTP, and gets back the response as XML.

This package contains some handy XML-RPC demo applications.


%description doc
The %{name}-doc package contains documentation files for %{name}.


%prep
%autosetup -Sgit

%build
%configure
%make_build

# Parallel builds trigger issues
pushd tools
make
popd

%install
%make_install
pushd tools
%make_install
popd

# remove static library
find %{buildroot} -name "*.a" -delete

%ldconfig_scriptlets
%ldconfig_scriptlets client
%ldconfig_scriptlets c++
%ldconfig_scriptlets client++

%generate_compatibility_deps

%files
%dir %{abidir}
%license doc/COPYING lib/abyss/license.txt
%{_libdir}/libxmlrpc_xml*.so.*
%{abidir}/libxmlrpc_xml*.dump
%{_libdir}/libxmlrpc_openssl.so.*
%{abidir}/libxmlrpc_openssl.dump
%{_libdir}/libxmlrpc.so.*
%{abidir}/libxmlrpc.dump
%{_libdir}/libxmlrpc_util.so.*
%{abidir}/libxmlrpc_util.dump
%{_libdir}/libxmlrpc_abyss.so.*
%{abidir}/libxmlrpc_abyss.dump
%{_libdir}/libxmlrpc_server.so.*
%{abidir}/libxmlrpc_server.dump
%{_libdir}/libxmlrpc_server_abyss.so.*
%{abidir}/libxmlrpc_server_abyss.dump
%{_libdir}/libxmlrpc_server_cgi.so.*
%{abidir}/libxmlrpc_server_cgi.dump

%files client
%{_libdir}/libxmlrpc_client.so.*
%{abidir}/libxmlrpc_client.dump

%files c++
%{_libdir}/libxmlrpc_cpp.so.*
%{abidir}/libxmlrpc_cpp.dump
%{_libdir}/libxmlrpc++.so.*
%{abidir}/libxmlrpc++.dump
%{_libdir}/libxmlrpc_util++.so.*
%{abidir}/libxmlrpc_util++.dump
%{_libdir}/libxmlrpc_abyss++.so.*
%{abidir}/libxmlrpc_abyss++.dump
%{_libdir}/libxmlrpc_server++.so.*
%{abidir}/libxmlrpc_server++.dump
%{_libdir}/libxmlrpc_server_abyss++.so.*
%{abidir}/libxmlrpc_server_abyss++.dump
%{_libdir}/libxmlrpc_server_cgi++.so.*
%{abidir}/libxmlrpc_server_cgi++.dump
%{_libdir}/libxmlrpc_packetsocket.so.*
%{abidir}/libxmlrpc_packetsocket.dump
%{_libdir}/libxmlrpc_server_pstream++.so.*
%{abidir}/libxmlrpc_server_pstream++.dump

%files client++
%{_libdir}/libxmlrpc_client++.so.*
%{abidir}/libxmlrpc_client++.dump

%files devel
%{_bindir}/xmlrpc-c-config
%{abidir}/xmlrpc-c-config-option.list
%{_includedir}/xmlrpc-c/
%{_includedir}/*.h
%{_libdir}/pkgconfig/xmlrpc*.pc
%{_libdir}/libxmlrpc*.so

%files apps
%{_bindir}/xmlrpc_parsecall
%{_bindir}/xmlrpc
%{_bindir}/xmlrpc_transport
%{_bindir}/xml-rpc-api2cpp
%{_mandir}/man1/xml-rpc-api2cpp.1*
%{_bindir}/xml-rpc-api2txt
%{_mandir}/man1/xml-rpc-api2txt.1*
%{_bindir}/xmlrpc_cpp_proxy
%{_bindir}/xmlrpc_pstream
%{abidir}/xmlrpc_pstream-option.list
%{_bindir}/xmlrpc_dumpserver

%files doc
%doc doc/CREDITS doc/HISTORY tools/xmlrpc_transport/xmlrpc_transport.html

%changelog
* Sat Mar 04 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 1.54.05-2
- optimize the spec file

* Fri Apr 15 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.54.05-1
- init from upstream
